function Xlift = cell2lift(Xcell,J,varargin)
%%CELL2LIFT Interleave LWT coefficients
%   Xlift = cell2lift(Xcell,J) interleave coefficients stored as separate 
%   arrays in Xcell for levels 1:J and approximation coefficients from 
%   level J to one array Xcell.
%
%   Xlift = cell2lift(Xcell,J,S) additionally the S denotes index of the
%   first sample in segment.
%
%   See also: lift2cell   

%   Author(s): Z. Prusa
%   $Revision: 1.0 $  $Date: 2011/05/02$ 

Nlift = 0;
for j = 1:J+1
    Nlift = Nlift + length(Xcell{j});
end

Xlift = zeros(Nlift,1);

index = 0;
if nargin>2
    index = varargin{1};
end

 firstIdxAPP= ceil(index/2^J)*2^J - index;
 
  firstIdxDET = zeros(J,1);
 for j = 1:J
    firstIdxDET(j)= ceil(index/2^j - 1/2)*2^j + 2^(j-1) - index;
 end


  firstIdxAPP =  firstIdxAPP + 1;
  firstIdxDET = firstIdxDET + 1;
  


for j=1:J
   L = length(firstIdxDET(j):2^j:Nlift);
    Xlift(firstIdxDET(j):2^j:Nlift) = Xcell{j};
end

Xlift(firstIdxAPP:2^J:Nlift) = Xcell{j+1};