 function [ Xout ] = cropLeft( Xin, left, firstIndex)
%%CROPLEFT Crop coefficients in each level from the left
%   Xout = cropLeft( Xin, left, firstIndex) Xin is cell containing separate
%   arrays of coefficients, left is scalar value denoting original extension
%   of segment from the left, firstIndex denotes index of the first
%   coefficient in segment.
%
%   See also: exJ, cropRight   

%   Author(s): Z. Prusa
%   $Revision: 1.0 $  $Date: 2011/05/02$ 
 
 firstIdxExt = firstIndex - left;
 
 J = size(Xin,1)-1;
 Xout = cell(J+1,1);
 
 firstIdxAPP = ceil(firstIdxExt/2^J);
 lastIdxAPP  = ceil(firstIndex/2^J);
 
 firstIdxDET = zeros(J,1);
 lastIdxDET = zeros(J,1);
 for j=1:J
   firstIdxDET(j)= ceil(firstIdxExt/2^j - 1/2); 
   lastIdxDET(j) = ceil(firstIndex/2^j - 1/2); 
end
 
%vechna detailn
for j = 1:J
    Xout{j} = Xin{j}(1+(lastIdxDET(j) - firstIdxDET(j )):end);
end

Xout{J+1} = Xin{J+1}(1+(lastIdxAPP - firstIdxAPP):end);
 

