 function [ Xout ] = cropRight( Xin, right,lastIndex )
 %%CROPRIGHT Crop coefficients in each level from the right
%   Xout = cropRighr( Xin, right, firstIndex) Xin is cell containing separate
%   arrays of coefficients, right is scalar value denoting original extension
%   of segment from the right, firstIndex denotes index of the first
%   coefficient in segment.
%
%   See also: exJ, cropRight   

%   Author(s): Z. Prusa
%   $Revision: 1.0 $  $Date: 2011/05/02$ 

 lastIdxExt = right + lastIndex;
 
 J = size(Xin,1)-1;
 Xout = cell(J+1,1);
 
 firstIdxAPP = floor(lastIndex/2^J);
 lastIdxAPP  = floor(lastIdxExt/2^J);
 
 firstIdxDET = zeros(J,1);
 lastIdxDET = zeros(J,1);
 for j=1:J
   firstIdxDET(j)= floor(lastIndex/2^j - 1/2); 
   lastIdxDET(j) = floor(lastIdxExt/2^j - 1/2); 
end
 
%vechna detailn
for j = 1:J
    Xout{j} = Xin{j}(1:end-(lastIdxDET(j) - firstIdxDET(j)));
end

Xout{J+1} = Xin{J+1}(1:end-(lastIdxAPP - firstIdxAPP));