function Xcell = lift2cell(Xlift,J,varargin)
%%LIFT2CELL Deinterleave LWT coefficients
%   Xcell = lift2cell(Xlift,J) deinterleave coefficients from Xlift for 
%   levels 1:J and approximation coefficients from level J to separate 
%   arrays in Xcell.
%
%   Xcell = lift2cell(Xlift,J,varargin) additionally the S denotes index of
%   the first sample in segment.
%
%   See also: lift2cell   

%   Author(s): Z. Prusa
%   $Revision: 1.0 $  $Date: 2011/05/02$ 

index = 0;
if nargin>2
    index = varargin{1};
end

 firstIdxAPP= ceil(index/2^J)*2^J - index;
 
  firstIdxDET = zeros(J,1);
 for j = 1:J
 firstIdxDET(j)= ceil(index/2^j - 1/2)*2^j + 2^(j-1) - index;
 end


  firstIdxAPP =  firstIdxAPP + 1;
  firstIdxDET = firstIdxDET + 1;
 
len = length(Xlift);
Xcell = cell(J+1,1);

for j=1:J
    indDET = firstIdxDET(j):2^j:len;
    Xcell{j} = Xlift(indDET);
end
indAPP = firstIdxAPP:2^J:len;

Xcell{j+1} = Xlift(indAPP);